<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deleteLicentiehouderRolRequest StructType
 * Meta informations extracted from the WSDL
 * - documentation: Verwijdert een rol bij een licentiehouder
 * @subpackage Structs
 */
class DeleteLicentiehouderRolRequest extends AbstractStructBase
{
    /**
     * The licentiehouderRolNo
     * Meta informations extracted from the WSDL
     * - documentation: Het nummer dat de rol bij de licentiehouder uniek identificeert.
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * - totalDigits: 15
     * @var int
     */
    public $licentiehouderRolNo;
    /**
     * The requestTag
     * Meta informations extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * - maxLength: 4000
     * @var string
     */
    public $requestTag;
    /**
     * Constructor method for deleteLicentiehouderRolRequest
     * @uses DeleteLicentiehouderRolRequest::setLicentiehouderRolNo()
     * @uses DeleteLicentiehouderRolRequest::setRequestTag()
     * @param int $licentiehouderRolNo
     * @param string $requestTag
     */
    public function __construct($licentiehouderRolNo = null, $requestTag = null)
    {
        $this
            ->setLicentiehouderRolNo($licentiehouderRolNo)
            ->setRequestTag($requestTag);
    }
    /**
     * Get licentiehouderRolNo value
     * @return int
     */
    public function getLicentiehouderRolNo()
    {
        return $this->licentiehouderRolNo;
    }
    /**
     * Set licentiehouderRolNo value
     * @param int $licentiehouderRolNo
     * @return \StructType\DeleteLicentiehouderRolRequest
     */
    public function setLicentiehouderRolNo($licentiehouderRolNo = null)
    {
        // validation for constraint: totalDigits
        if (is_float($licentiehouderRolNo) && strlen(str_replace(array(' ', '.', ',', '-', '+'), '', $licentiehouderRolNo)) !== 15) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must at most contain 15 digits, "%d" given', strlen(substr($licentiehouderRolNo, strpos($licentiehouderRolNo, '.')))), __LINE__);
        }
        // validation for constraint: int
        if (!is_null($licentiehouderRolNo) && !is_numeric($licentiehouderRolNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($licentiehouderRolNo)), __LINE__);
        }
        $this->licentiehouderRolNo = $licentiehouderRolNo;
        return $this;
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \StructType\DeleteLicentiehouderRolRequest
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($requestTag) && strlen($requestTag) > 4000) || (is_array($requestTag) && count($requestTag) > 4000)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 4000 element(s) or a scalar of 4000 character(s) at most, "%d" length given', is_scalar($requestTag) ? strlen($requestTag) : count($requestTag)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeleteLicentiehouderRolRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
