<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for stopGratisAboPerDirectResponse StructType
 * Meta informations extracted from the WSDL
 * - documentation: error1: Ongeldige combinatie van argumenten: geef ofwel een aboNo op, ofwel een combiniatie van een relNo en uitgaveCode met evt. een abosoortCode, | error2: Het abonnement is niet gevonden op basis van de opgegeven aboNo. | error3:
 * Kan geen relatie vinden obv de opgegeven relNo | error4: Kan geen uitgave vinden obv de opgegeven uitgaveCode. | error5: Kan geen abonnementsoort vinden obv de opgegeven abosoortCode. | error6: De opgegeven abosoortCode hoort niet bij de opgegeven
 * uitgaveCode. | error7: Er is geen abonnement gevonden op basis van de opgegeven relNo, uitgaveCode en abosoortCode | error8: De inrichting van de uitgave of abonnementsoort voldoet niet aan de voorwaarden. | error9: Het abonnement is reeds gestopt. |
 * error10: De stopreden is niet gevonden.
 * @subpackage Structs
 */
class StopGratisAboPerDirectResponse extends AbstractStructBase
{
    /**
     * The stopDatum
     * Meta informations extracted from the WSDL
     * - documentation: De datum waarop het abonnement is stopgezet
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $stopDatum;
    /**
     * The requestTag
     * Meta informations extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * - maxLength: 4000
     * @var string
     */
    public $requestTag;
    /**
     * Constructor method for stopGratisAboPerDirectResponse
     * @uses StopGratisAboPerDirectResponse::setStopDatum()
     * @uses StopGratisAboPerDirectResponse::setRequestTag()
     * @param string $stopDatum
     * @param string $requestTag
     */
    public function __construct($stopDatum = null, $requestTag = null)
    {
        $this
            ->setStopDatum($stopDatum)
            ->setRequestTag($requestTag);
    }
    /**
     * Get stopDatum value
     * @return string
     */
    public function getStopDatum()
    {
        return $this->stopDatum;
    }
    /**
     * Set stopDatum value
     * @param string $stopDatum
     * @return \StructType\StopGratisAboPerDirectResponse
     */
    public function setStopDatum($stopDatum = null)
    {
        // validation for constraint: string
        if (!is_null($stopDatum) && !is_string($stopDatum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stopDatum)), __LINE__);
        }
        $this->stopDatum = $stopDatum;
        return $this;
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \StructType\StopGratisAboPerDirectResponse
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($requestTag) && strlen($requestTag) > 4000) || (is_array($requestTag) && count($requestTag) > 4000)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 4000 element(s) or a scalar of 4000 character(s) at most, "%d" length given', is_scalar($requestTag) ? strlen($requestTag) : count($requestTag)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StopGratisAboPerDirectResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
